(in-package #:org.shirakumo.alloy.examples)

(define-example clipping (screen)
  (let* ((window (windowing:make-window screen :min-size (alloy:px-size 640 480)))
         (focus (make-instance 'alloy:visual-focus-manager :focus-parent window))
         (border (make-instance 'alloy:border-layout :layout-parent window))
         (clip (make-instance 'alloy:clip-view :layout-parent border))
         (scroll-y (alloy:represent-with 'alloy:y-scrollbar clip :focus-parent focus))
         (scroll-x (alloy:represent-with 'alloy:x-scrollbar clip :focus-parent focus))
         (layout (make-instance 'alloy:vertical-linear-layout :layout-parent clip)))
    (alloy:enter scroll-y border :place :west :size (alloy:un 20))
    (alloy:enter scroll-x border :place :south :size (alloy:un 20))
    
    (alloy:represent "Nesting" 'alloy:button :layout-parent layout :focus-parent focus)
    (let* ((border (make-instance 'alloy:border-layout :layout-parent layout))
           (clip (make-instance 'alloy:clip-view :limit :y :layout-parent border))
           (layout (make-instance 'alloy:horizontal-linear-layout :layout-parent clip))
           (scroll-x (alloy:represent-with 'alloy:x-scrollbar clip :focus-parent focus)))
      (alloy:enter scroll-x border :place :south :size (alloy:un 10))
      (dotimes (j 20)
        (alloy:enter (format NIL "Item ~d"  j) layout)))

    (dotimes (i 6)
      (alloy:represent (format NIL "Group ~d" i) 'alloy:button :layout-parent layout :focus-parent focus)
      (let ((layout (make-instance (if (evenp i) 'alloy:vertical-linear-layout 'alloy:horizontal-linear-layout)
                                   :layout-parent layout)))
        (dotimes (j 10)
          (alloy:enter (format NIL "Item ~d/~d" i j) layout))))))
